'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cachePath = '.wemixcache';
var _buildCache = null;
var _cacheChanged = false;
var _filelistCache = {};

exports.default = {
  setParams(v) {
    this._params = v;
  },
  getParams() {
    return this._params;
  },
  setAppPath(v) {
    this._appPath = v;
  },
  getAppPath() {
    return this._appPath;
  },
  getSrc() {
    return this._src || 'src';
  },
  setSrc() {
    var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'src';

    this._src = v;
  },
  getDist() {
    return this._dist || 'dist';
  },
  setDist() {
    var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'dist';

    this._dist = v;
  },
  setPages() {
    var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    this._pages = v;
  },
  getPages() {
    return this._pages || [];
  },
  getConfig() {
    return this._config || null;
  },
  setConfig() {
    var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

    this._config = v;
  },
  setFileList(key, v) {
    _filelistCache[key] = v;
  },
  getFileList(key) {
    return _filelistCache[key] || null;
  },
  getBuildCache(file) {
    if (_buildCache) return _buildCache;

    if (_util2.default.isFile(cachePath)) {
      _buildCache = _util2.default.readFile(cachePath);
      try {
        _buildCache = JSON.parse(_buildCache);
      } catch (e) {
        _buildCache = null;
      }
    }

    return _buildCache || {};
  },
  setBuildCache(file) {
    var cache = this.getBuildCache();
    cache[file] = _util2.default.getModifiedTime(file);
    _buildCache = cache;
    _cacheChanged = true;
  },
  clearBuildCache() {
    _util2.default.unlink(cachePath);
  },
  saveBuildCache() {
    if (_cacheChanged) {
      _util2.default.writeFile(cachePath, (0, _stringify2.default)(_buildCache || {}));
      _cacheChanged = false;
    }
  },
  checkBuildCache(file) {
    var cache = this.getBuildCache();
    return cache[file] && cache[file] === _util2.default.getModifiedTime(file);
  }
};
//# sourceMappingURL=cache.js.map