'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _xmldom = require('xmldom');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _compileWemix = require('./compile-wemix');

var _compileWemix2 = _interopRequireDefault(_compileWemix);

var _compileStyle = require('./compile-style');

var _compileStyle2 = _interopRequireDefault(_compileStyle);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

var _cache = require('./cache');

var _cache2 = _interopRequireDefault(_cache);

var _loader = require('./loader');

var _loader2 = _interopRequireDefault(_loader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PREFIX = '$';
var JOIN = '$';

exports.default = {
  replaceVariable(str, n) {
    var stash = [],
        rst = '';
    for (var i = n, l = str.length; i < l; i++) {
      if (str[i] === '{') stash.push('{');
      if (str[i] === '}') {
        stash.pop();
        if (stash.length === 0) {
          rst += '}';
          break;
        }
      }
      if (stash.length) {
        rst += str[i];
      }
    }
    return rst;
  },
  replacePropsAttr(opath, pe, defaultProps, match, attr, code, slot) {
    var node = _compileWemix2.default.createParser().parseFromString(match);
    var newAttr = {};
    var formatNewAttr = {};
    var viewType = 'view';
    pe.events[node.documentElement.nodeName] = pe.events[node.documentElement.nodeName] || {};
    [].slice.call(node.documentElement.attributes || []).forEach(function (attr) {
      if (attr.name === 'view:type') {
        viewType = attr.value;
      }
      if (attr.name.substr(0, 5) === 'v-on:') {
        pe.events[node.documentElement.nodeName][attr.name.substr(5)] = attr.value;
      } else if (!/^(wx:|hidden)/.test(attr.name)) {
        var needFormat = false;
        formatNewAttr[attr.name] = attr.value.replace(/{{\s*([^}]+)\s*}}/g, function (match, name) {
          if (name.indexOf('||') > -1 || name.indexOf('&&') > -1) {
            _util2.default.error(`不支持的语法：${attr.name}=${attr.value}`, '错误');
          }
          if (attr.name.substr(0, 7) === 'static:') {
            if (name.match(/\#{\s*([\s\S]+?)\s*\}/)) {
              _util2.default.error(`不支持的语法：${name}`, '错误');
            }
            if (name.match(/"\s*([^"]+)\s*"/)) {
              return name.replace(/"\s*([^"]+)\s*"/, function (match, acName) {
                return acName;
              });
            } else if (name.match(/'\s*([^']+)\s*'/)) {
              return name.replace(/'\s*([^']+)\s*'/, function (match, acName) {
                return acName;
              });
            } else {
              needFormat = true;
              return name;
            }
          } else {
            return name;
          }
        });
        if (needFormat) {
          formatNewAttr[attr.name] = new Function(`return ${formatNewAttr[attr.name]}`)();
        }
      }
    });
    pe.props[node.documentElement.nodeName] = pe.props[node.documentElement.nodeName] || {};
    for (var key in formatNewAttr) {
      var staticAttr = key && key.substr(0, 7) === 'static:';
      if (staticAttr) {
        newAttr[key.substr(7)] = formatNewAttr[key];
        pe.props[node.documentElement.nodeName][key.substr(7)] = { static: true, value: newAttr[key.substr(7)], defaultValue: defaultProps && defaultProps[key.substr(7)] && defaultProps[key.substr(7)].value };
      } else {
        newAttr[key] = formatNewAttr[key];
        pe.props[node.documentElement.nodeName][key] = { value: newAttr[key], defaultValue: defaultProps && defaultProps[key] && defaultProps[key].value };
      }
    }
    var formatComContent = code;
    var index = formatComContent.indexOf('#{');
    var rst = void 0,
        name = void 0;
    while (index > -1) {
      rst = this.replaceVariable(formatComContent, index + 1);
      name = rst.substr(1, rst.length - 2);
      var split = name.split('.');
      if (split[0] === 'props') {
        if (split[1] === 'children') {
          formatComContent = formatComContent.replace(`#${rst}`, slot);
        } else {
          if (split.length > 2) {
            var defaultValue = void 0;
            try {
              defaultValue = new Function(`return ${pe.props[node.documentElement.nodeName][split[1]]['defaultValue']}.${split.slice(2).join('.')}`)();
              formatComContent = formatComContent.replace(`#${rst}`, `(${newAttr[split[1]]}.${split.slice(2).join('.')} || ${defaultValue})`);
            } catch (e) {
              formatComContent = formatComContent.replace(`#${rst}`, `${newAttr[split[1]]}.${split.slice(2).join('.')}`);
            }
          } else {
            if (pe.events[node.documentElement.nodeName][split[1]]) {
              formatComContent = formatComContent.replace(`#${rst}`, pe.events[node.documentElement.nodeName][split[1]]);
            } else if (pe.props[node.documentElement.nodeName][split[1]]) {
              if (pe.props[node.documentElement.nodeName][split[1]]['static']) {
                if (_util2.default.isNoValue(pe.props[node.documentElement.nodeName][split[1]]['value'])) {
                  formatComContent = formatComContent.replace(`#${rst}`, pe.props[node.documentElement.nodeName][split[1]]['defaultValue']);
                } else {
                  formatComContent = formatComContent.replace(`#${rst}`, pe.props[node.documentElement.nodeName][split[1]]['value']);
                }
              } else {
                if (_util2.default.isNoValue(pe.props[node.documentElement.nodeName][split[1]]['defaultValue'])) {
                  formatComContent = formatComContent.replace(`#${rst}`, `${pe.props[node.documentElement.nodeName][split[1]]['value']}`);
                } else {
                  formatComContent = formatComContent.replace(`#${rst}`, `(${pe.props[node.documentElement.nodeName][split[1]]['value']} || ${pe.props[node.documentElement.nodeName][split[1]]['defaultValue']})`);
                }
              }
            } else {
              formatComContent = formatComContent.replace(`#${rst}`, undefined);
            }
          }
        }
      } else {
        formatComContent = formatComContent.replace(`#${rst}`, `$${node.documentElement.nodeName}$${name}`);
      }
      index = formatComContent.indexOf('#{');
    }
    return `<${viewType} id='${node.documentElement.nodeName}' ${attr}>${formatComContent}</${viewType}>`;
  },
  compileXML(content, template, pe) {
    var _this = this;

    var customElements = [];
    (0, _keys2.default)(template.components).forEach(function (com) {
      var definePath = template.components[com];
      definePath = definePath.indexOf('.') === -1 ? definePath : _path2.default.resolve(template.src, '..' + _path2.default.sep + template.components[com]);
      var src = _util2.default.findComponent(definePath);
      if (!src) {
        _util2.default.error('找不到组件：' + definePath, '错误');
      } else {
        var wmix = _compileWemix2.default.resolveWemix(src);
        var opath = _path2.default.parse(definePath);

        _compileStyle2.default.compile('less', wmix.style.code, opath, wmix.style.components);

        content = content.replace(new RegExp(`<${com}([\\s\\S]+?)\/>`, 'g'), function (match, attr) {
          return _this.replacePropsAttr(opath, pe, wmix.template.defaultProps, match, attr, wmix.template.code);
        });
        content = content.replace(new RegExp(`<${com}([\\s\\S]+?)>([\\s\\S]*?)<\/${com}>`, 'g'), function (match, attr, slot) {
          return _this.replacePropsAttr(opath, pe, wmix.template.defaultProps, match, attr, wmix.template.code, slot);
        });

        content = _this.compileXML(content, wmix.template, pe);
      }
    });
    return content;
  },
  compile(template) {
    var pe = {
      props: {},
      events: {}
    };
    var content = template.code;
    var config = _util2.default.getConfig();
    var src = _cache2.default.getSrc();
    var dist = _cache2.default.getDist();
    var self = this;

    if (content) {
      var index = content.indexOf('#{');
      var rst = void 0,
          name = void 0;
      while (index > -1) {
        rst = this.replaceVariable(content, index + 1);
        name = rst.substr(1, rst.length - 2);
        content = content.replace(`#${rst}`, name);
        index = content.indexOf('#{');
      }
      content = this.compileXML(content, template, pe);
    }
    var target = _util2.default.getDistPath(_path2.default.parse(template.src), 'wxml', src, dist);

    var plg = new _loader2.default.PluginHelper(config.plugins, {
      type: 'wxml',
      code: content,
      file: target,
      output(p) {
        _util2.default.output(p.action, p.file);
      },
      done(rst) {
        _util2.default.output('写入', rst.file);
        _util2.default.writeFile(target, rst.code);
      }
    });
    return pe;
  }
};
//# sourceMappingURL=compile-html.js.map