'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; (0, _defineProperty2.default)(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('module');

var _module2 = _interopRequireDefault(_module);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _util = require('./util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var relativeModules = {};
var requiredModules = {};

var loadedPlugins = [];

var PluginHelper = function () {
  function PluginHelper(plugins, op) {
    _classCallCheck(this, PluginHelper);

    this.applyPlugin(0, op);
    return true;
  }

  _createClass(PluginHelper, [{
    key: 'applyPlugin',
    value: function applyPlugin(index, op) {
      var _this = this;

      var plg = loadedPlugins[index];

      if (!plg) {
        op.done && op.done(op);
      } else {
        op.next = function () {
          _this.applyPlugin(index + 1, op);
        };
        op.catch = function () {
          op.error && op.error(op);
        };
        if (plg) plg.apply(op);
      }
    }
  }]);

  return PluginHelper;
}();

exports.default = {
  loadCompiler(lang) {
    if (['wxml', 'xml', 'css', 'js'].indexOf(lang) > -1) {
      return function (c) {
        return _promise2.default.resolve(c);
      };
    }
    var name = 'wemix-compiler-' + lang;
    var compiler = this.load(name);

    if (!compiler) {
      _util2.default.log(`找不到编译器：${name}。`, 'warning');
    }
    return compiler.default;
  },
  load(name) {
    if (requiredModules[name]) return requiredModules[name];
    var m = require('./' + name + '.js');
    requiredModules[name] = m;
    return m;
  },
  loadPlugin(plugins, op) {
    var plg = void 0,
        plgkey = void 0,
        setting = void 0,
        config = void 0;
    for (plgkey in plugins) {
      var name = 'wemix-plugin-' + plgkey;
      setting = plugins[plgkey];
      plg = this.load(name);

      if (!plg) {
        _util2.default.log(`找不到插件：${name}。`, 'warning');
      }
      loadedPlugins.push(new plg.default(setting));
    }
  },
  PluginHelper: PluginHelper
};
//# sourceMappingURL=loader.js.map