'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = function (content, config, file) {
  return new _promise2.default(function (resolve, reject) {
    var opath = _path2.default.parse(file);
    var conf = {
      paths: [opath.dir]
    };
    if (config.compress) {
      var cleanCSSPlugin = new _lessPluginCleanCss2.default({ advanced: true });
      conf.plugins = [cleanCSSPlugin];
    }
    _less2.default.render(content, conf).then(function (res) {
      resolve(res.css);
    }).catch(function (error) {
      console.log(error);
      reject(error);
    });
  });
};

var _less = require('less');

var _less2 = _interopRequireDefault(_less);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lessPluginCleanCss = require('less-plugin-clean-css');

var _lessPluginCleanCss2 = _interopRequireDefault(_lessPluginCleanCss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=wemix-compiler-less.js.map